<script setup lang="ts">
////////////////////////////////
// IMPORT
////////////////////////////////

import { useSampleStore } from "@/stores/useSampleStore";
import { JsonForms } from "@jsonforms/vue";
import { vuetifyRenderers } from "@jsonforms/vue-vuetify";

////////////////////////////////
// PROPS
////////////////////////////////

const props = defineProps({
  newSampleDialog: {
    type: Boolean,
    required: true,
  },
});

////////////////////////////////
// EMITS
////////////////////////////////

const emits = defineEmits(["newSampleDialog"]);

////////////////////////////////
// DATA
////////////////////////////////

const sampleStore = useSampleStore();

const drawer = ref(false);

// Initialize AJV
const ajv = newAjv();
const renderers = markRaw([...vuetifyRenderers]);

const data = ref({});
const schema = ref({});
const errors = ref([]);
const submitDisabled = ref(false);
let validate;

onMounted(async () => {
  const { data: temp } = await useAPIFetch("/api/schemas/referential/sample?ref=False");
  schema.value = temp.value;
  validate = ajv.compile(schema.value);
});

////////////////////////////////
// WATCH
////////////////////////////////

watch(
  () => props.newSampleDialog,
  (newValue) => {
    drawer.value = newValue;
  },
);

////////////////////////////////
// METHODS
////////////////////////////////

async function close() {
  drawer.value = false;
  emits("newSampleDialog", false);
  data.value = {};
  errors.value = [];
}

// The `async function checkData()` is a method that is responsible for
// validating the data using the AJV (Another JSON Schema Validator) instance
// created earlier.
async function checkData() {
  const valid = validate(data.value);
  if (valid) {
    submitDisabled.value = false;
    return true;
  } else {
    errors.value = validate.errors || [];
    submitDisabled.value = true;
    return false;
  }
}

// The `onChange` function is updating the `data` value with the data from the
// event passed as a parameter, and then it calls the `checkData` function to
// validate the updated data. This function is typically used as an event handler
// for changes in the input fields or form elements to keep the data in sync and
// validate it whenever there is a change.
function onChange(event) {
  if (!data.value?.alias) {
    data.value.manualAlias = false;
    event.data.manualAlias = false;
  }
  if (event.data?.alias === data.value?.alias && event.data?.title && !data.value?.manualAlias) {
    event.data.alias = event.data.title
      .normalize("NFD") // split an accented letter in the base letter and the acent
      .replace(/[\u0300-\u036F]/g, "") // remove all previously split accents
      .toLowerCase()
      .trim()
      .replace(/[^a-z0-9 ]/g, "") // remove all chars not letters, numbers and spaces (to be replaced)
      .replace(/\s+/g, "-"); // separator
    event.data.manualAlias = false;
  } else if (event.data?.alias !== data.value?.alias) {
    event.data.manualAlias = true;
  }
  data.value = event.data;
  checkData();
}

// The `async function createSample()` is a method that is responsible for
// creating a new sample.
async function createSample() {
  if (await checkData()) {
    try {
      await sampleStore.createSample(data.value.title, data.value.alias);
      await sampleStore.fetchSamples();
      close();
    } catch (error) {
      console.error("Error creating new sample:", error);
    }
  }
}
</script>

<template>
  <v-dialog
    v-model="drawer"
    width="50%"
    persistent
  >
    <v-card>
      <v-card-title class="d-flex">
        <v-sheet
          class="me-auto"
          style="
            overflow: hidden;
            white-space: nowrap;
            text-overflow: ellipsis;
            width: calc(100%-30);
          "
        >
          {{ $t("new_sample") }}
        </v-sheet>
        <v-sheet>
          <v-btn
            icon="$close"
            density="comfortable"
            variant="plain"
            @click="close"
          />
        </v-sheet>
      </v-card-title>
      <v-card-text>
        <p class="mb-4">
          {{ $t("sample_text") }}
        </p>
        <JsonForms
          :data="data"
          :schema="schema"
          :renderers="renderers"
          :ajv="ajv"
          :errors="errors"
          @change="onChange($event)"
        />

        <div class="d-flex flex-row-reverse">
          <v-btn
            color="primary"
            class="mt-2"
            :disabled="submitDisabled"
            @click="createSample()"
          >
            Create
          </v-btn>
        </div>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>
